searchData={"items":[{"type":"task","title":"mix www_redirect.install","doc":"Installs WwwRedirect into your Endpoint.\n\nInstalls the WwwRedirect Plug in your Endpoint.","ref":"Mix.Tasks.WwwRedirect.Install.html"},{"type":"task","title":"Example - mix www_redirect.install","doc":"```sh\nmix www_redirect.install\n```","ref":"Mix.Tasks.WwwRedirect.Install.html#module-example"},{"type":"module","title":"WwwRedirect","doc":"Redirects an HTTP request from WWW to Non-WWW and vice versa.\n\nHeavily inspired by: https://stackoverflow.com/a/36509559","ref":"WwwRedirect.html"},{"type":"module","title":"Options - WwwRedirect","doc":"* `:to` - Specifies the redirect target. Can be `:www` or `:non_www` (default).\n  - `:www` - Redirects bare domains to www versions (e.g., example.com -> www.example.com)\n  - `:non_www` (default) - Redirects www domains to bare versions (e.g., www.example.com -> example.com)","ref":"WwwRedirect.html#module-options"},{"type":"module","title":"Examples - WwwRedirect","doc":"# Redirect to non-www\n    plug WwwRedirect\n    plug WwwRedirect, to: :non_www\n\n    # Redirect to www\n    plug WwwRedirect, to: :www","ref":"WwwRedirect.html#module-examples"},{"type":"function","title":"WwwRedirect.call/2","doc":"","ref":"WwwRedirect.html#call/2"},{"type":"function","title":"WwwRedirect.init/1","doc":"","ref":"WwwRedirect.html#init/1"},{"type":"extras","title":"WwwRedirect","doc":"# WwwRedirect\n\nA Plug for redirecting HTTP requests between www and non-www versions of domains.\n\nThis library redirects requests between `www.example.com` and `example.com` based on your preference.","ref":"readme.html"},{"type":"extras","title":"Installation - WwwRedirect","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `www_redirect` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:www_redirect, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Install with Igniter - WwwRedirect","doc":"```\nmix igniter.install www_redirect\n```","ref":"readme.html#install-with-igniter"},{"type":"extras","title":"Usage - WwwRedirect","doc":"```elixir\n# Redirect to non-www (default behavior)\n# E.g. `www.example.com` -> `example.com`\nplug WwwRedirect\nplug WwwRedirect, to: :non_www\n\n# Redirect to www\n# E.g. `https://example.com/path` -> `https://www.example.com/path`\nplug WwwRedirect, to: :www\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration Options - WwwRedirect","doc":"The plug accepts the following options:\n\n- `:to` - Specifies the redirect target. Can be `:www` (default) or `:non_www`.\n  - `:www` - Redirects bare domains to www versions (e.g., `example.com` → `www.example.com`)\n  - `:non_www` - Redirects www domains to bare versions (e.g., `www.example.com` → `example.com`)","ref":"readme.html#configuration-options"},{"type":"extras","title":"Fixing Tests - WwwRedirect","doc":"Phoenix/Plug sets the `conn.host` to `www.example.com` by default, which might break your tests after adding `WwwRedirect` to your endpoint. Unfortunately, it's not possible to configure the `conn.host` in test globally since it's [a default value](https://github.com/elixir-plug/plug/blob/065976d85f3d079d4f22dde7897c2e7f67c596e0/lib/plug/adapters/test/conn.ex#L50) but you can update your `conn_case.ex` like this:\n\n```elixir\n# test/support/conn_case.ex\n\n# ...\nsetup tags do\n  # ...\n  {:ok, conn: Phoenix.ConnTest.build_conn() |> Map.put(:host, \"example.com\")}\nend\n```\n\nThis will set the `conn.host` to `example.com` instead of `www.example.com` in all your tests. You can always set it back by running `Map.put(conn, :host, \"www.example.com\")` in your test.","ref":"readme.html#fixing-tests"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2025 Peter Ullrich\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}